/*
 * Copyright 2016 - 2021 gary@drinkingtea.net
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */

#pragma once

#include <ox/std/error.hpp>
#include <ox/std/memory.hpp>
#include <ox/std/vector.hpp>

namespace nostalgia::studio {

class UndoCommand {
	public:
		virtual ~UndoCommand() noexcept = default;
		virtual void redo() noexcept = 0;
		virtual void undo() noexcept = 0;
};

class UndoStack {
	private:
		ox::Vector<ox::UniquePtr<UndoCommand>> m_stack;
		std::size_t m_stackIdx = 0;

	public:
		void push(UndoCommand *cmd) noexcept;

		void redo() noexcept;

		void undo() noexcept;
};

}